%global majorversion 2
%global minorversion 15
%global patchversion 0
%global majorminorversion %{majorversion}.%{minorversion}
%global nsversion %{majorversion}.0

%global libmodulemd_version %{majorminorversion}%{?patchversion:.%{patchversion}}

%global libname %mklibname modulemd %{majorversion}
%global devname %mklibname modulemd -d
%global girname %mklibname modulemd-gir %{nsversion}

%bcond_with check

Name:           libmodulemd
Version:        %{libmodulemd_version}
Release:        %mkrel 6
Summary:        Module metadata manipulation library
Group:          System/Packaging
# COPYING:	MIT
## not in any binary package
# contrib/coverity-modeling.c:	GPLv2+
# contrib/release-tools/semver:	GPLv3
License:        MIT
URL:            https://github.com/fedora-modularity/libmodulemd
Source0:        https://github.com/fedora-modularity/libmodulemd/releases/download/%{version}/modulemd-%{libmodulemd_version}.tar.xz
# Fix building with glib2-doc 2.79.0, in upstream after 2.15.0
Patch0:         modulemd-2.15.0-build-Move-computing-gtk-doc-module-paths-to-the-che.patch
Patch1:         modulemd-2.15.0-doc-Adapt-GLib-documentation-path-to-GLib-2.79.0.patch
# Fix building with glib2-doc 2.80.1, in upstream after 2.15.0,
# <https://github.com/fedora-modularity/libmodulemd/pull/619>.
Patch2:         modulemd-2.15.0-doc-Adapt-GLib-documentation-path-to-GLib-2.80.1.patch

BuildRequires:  meson >= 0.47.0
BuildRequires:  gcc
BuildRequires:  pkgconfig(gobject-2.0)
BuildRequires:  pkgconfig(gobject-introspection-1.0)
BuildRequires:  pkgconfig(yaml-0.1)
BuildRequires:  pkgconfig(gtk-doc)
BuildRequires:  python3dist(pygobject)
BuildRequires:  python3dist(pygments)
BuildRequires:  rpm-devel
BuildRequires:  file-devel

%description
C library for manipulating module metadata files.


%package -n modulemd-validator
Summary:        Tool for validating modulemd data
Group:          System/Packaging
Requires:       %{libname}%{?_isa} = %{libmodulemd_version}-%{release}
# modulemd-v1 is gone
Obsoletes:      modulemd-validator-v1 < 1.8.16-3

%description -n modulemd-validator
The modulemd-validator tool provides the facility for verifying
constructed modulemd data is correct and usable.

%package -n python3-%{name}
Summary:        Python 3 bindings for %{name}
Group:          Development/Python
Requires:       %{girname}%{?_isa} = %{libmodulemd_version}-%{release}
Requires:       python3dist(pygobject)
Requires:       python3dist(six)

%description -n python3-%{name}
This package provides the Python 3 bindings for %{name}.

%package -n %{libname}
Summary:        Main library for %{name}
Group:          System/Libraries
Provides:       %{name} = %{version}-%{release}
Provides:       %{name}%{?_isa} = %{version}-%{release}
# modulemd-v1 is gone
Obsoletes:      %{mklibname modulemd 1} < 1.8.16-3

%description -n %{libname}
This package provides the main library for applications
that use %{name}.

%package -n %{girname}
Summary:        GObject Introspection interface description for %{name}
Group:          System/Libraries
Requires:       %{libname}%{?_isa} = %{libmodulemd_version}-%{release}
# modulemd-v1 is gone
Obsoletes:      %{mklibname modulemd-gir 1.0} < 1.8.16-3

%description -n %{girname}
This package provides the GObject Introspection typelib interface
for applications to use %{name}.

%package -n %{devname}
Summary:        Development files for %{name}
Group:          Development/C
Provides:       %{name}-devel = %{libmodulemd_version}-%{release}
Provides:       %{name}-devel%{?_isa} = %{libmodulemd_version}-%{release}
Provides:       modulemd-devel = %{libmodulemd_version}-%{release}
Provides:       modulemd-devel%{?_isa} = %{libmodulemd_version}-%{release}
Requires:       %{libname}%{?_isa} = %{libmodulemd_version}-%{release}
Requires:       %{girname}%{?_isa} = %{libmodulemd_version}-%{release}
# modulemd-v1 is gone
Obsoletes:      %{mklibname modulemd 1 -d} < 1.8.16-3

%description -n %{devname}
This package provides files for developing applications to use %{name}.

%prep
%autosetup -p1 -n modulemd-%{libmodulemd_version}

%build
%meson \
    -Dlibmagic=enabled \
    -Drpmio=enabled \
    -Dskip_introspection=false \
    -Dtest_installed_lib=false \
    -Dwith_docs=true \
    -Dwith_manpages=enabled \
    -Dwith_py3=true \
    -Dwith_py2=false

%meson_build

%if %{with check}
%check
export LC_CTYPE=C.UTF-8
%meson_test -t 5
%endif

%install
%meson_install

%files -n modulemd-validator
%license COPYING
%doc NEWS README.md
%{_bindir}/modulemd-validator
%{_mandir}/man1/modulemd-validator.1*

%files -n python3-%{name}
%{python3_sitearch}/gi/overrides/Modulemd.py
%{python3_sitearch}/gi/overrides/__pycache__/Modulemd.*

%files -n %{libname}
%license COPYING
%doc README.md
%{_libdir}/%{name}.so.%{majorversion}{,.*}

%files -n %{girname}
%{_libdir}/girepository-1.0/Modulemd-%{nsversion}.typelib

%files -n %{devname}
%{_libdir}/%{name}.so
%{_libdir}/pkgconfig/modulemd-%{nsversion}.pc
%{_includedir}/modulemd-%{nsversion}/
%{_datadir}/gir-1.0/Modulemd-%{nsversion}.gir
%{_datadir}/gtk-doc/html/modulemd-%{nsversion}/


%changelog
* Wed Jul 02 2025 umeabot <umeabot> 2.15.0-6.mga10
+ Revision: 2237678
- Mageia 10 Mass Rebuild

* Fri Feb 28 2025 wally <wally> 2.15.0-5.mga10
+ Revision: 2153837
- rebuild for python3.13

* Fri Oct 18 2024 daviddavid <daviddavid> 2.15.0-4.mga10
+ Revision: 2108107
- fix building with glib2-doc 2.80.1

* Thu Dec 07 2023 wally <wally> 2.15.0-3.mga10
+ Revision: 2015199
- rebuild for py3.12

* Wed Nov 22 2023 wally <wally> 2.15.0-2.mga10
+ Revision: 2009196
- add libmodulemd provides to lib pkg

* Mon Nov 20 2023 wally <wally> 2.15.0-1.mga10
+ Revision: 2008504
- new version 2.15.0

* Sun Nov 12 2023 daviddavid <daviddavid> 2.14.0-4.mga10
+ Revision: 2006243
- rebuild for new rpm 4.19.0

* Thu Mar 31 2022 umeabot <umeabot> 2.14.0-3.mga9
+ Revision: 1836344
- Mageia 9 Mass Rebuild

* Sat Feb 12 2022 wally <wally> 2.14.0-2.mga9
+ Revision: 1773441
- rebuild for python3.10

* Fri Feb 11 2022 luigiwalser <luigiwalser> 2.14.0-1.mga9
+ Revision: 1773105
- 2.14.0

* Sun Feb 06 2022 wally <wally> 2.13.0-2.mga9
+ Revision: 1772306
- rebuild for python3.10

* Tue Jul 13 2021 luigiwalser <luigiwalser> 2.13.0-1.mga9
+ Revision: 1735834
- 2.13.0

* Mon Mar 15 2021 wally <wally> 2.12.0-2.mga9
+ Revision: 1703536
- rebuild for python 3.9

* Mon Jan 18 2021 luigiwalser <luigiwalser> 2.12.0-1.mga8
+ Revision: 1672362
- 2.12.0

* Wed Dec 30 2020 luigiwalser <luigiwalser> 2.11.1-1.mga8
+ Revision: 1665459
- 2.11.1
- remove upstreamed patch

* Wed Dec 02 2020 luigiwalser <luigiwalser> 2.10.0-1.mga8
+ Revision: 1651752
- 2.10.0
- add 32-bit fix from fedora
- fix source URL

* Tue Jul 07 2020 ngompa <ngompa> 2.9.4-1.mga8
+ Revision: 1602719
- Update to 2.9.4

* Fri Feb 28 2020 ngompa <ngompa> 2.9.1-1.mga8
+ Revision: 1551702
- Update to 2.9.1
- Obsolete modulemd-v1 packages

* Wed Feb 19 2020 umeabot <umeabot> 2.8.3-2.mga8
+ Revision: 1543444
- Mageia 8 Mass Rebuild

* Sun Jan 19 2020 ngompa <ngompa> 2.8.3-1.mga8
+ Revision: 1481568
- Update to 2.8.3

* Sun Dec 08 2019 ngompa <ngompa> 2.8.2-1.mga8
+ Revision: 1465097
- Update to 2.8.2
- libmodulemd1 has been split out into its own tarball/source package

* Sat Sep 21 2019 daviddavid <daviddavid> 2.5.0-2.mga8
+ Revision: 1444476
- rebuild for python3.8

* Tue May 28 2019 ngompa <ngompa> 2.5.0-1.mga7
+ Revision: 1399317
- Update to 2.5.0 (v2) and 1.8.11 (v1)

* Sun May 12 2019 ngompa <ngompa> 2.3.1-1.mga7
+ Revision: 1397460
- Update to 2.3.1 (v2) and 1.8.8 (v1)

* Sun Apr 28 2019 ngompa <ngompa> 2.3.0-2.mga7
+ Revision: 1395806
- Add missing dependency on six module for Python 3 bindings subpackage

* Tue Apr 23 2019 ngompa <ngompa> 2.3.0-1.mga7
+ Revision: 1394895
- Update to 2.3.0 (v2) and 1.8.7 (v1)

* Thu Apr 18 2019 umeabot <umeabot> 2.2.2-2.mga7
+ Revision: 1392788
- Rebuild with meson 0.50.1

* Mon Apr 01 2019 ngompa <ngompa> 2.2.2-1.mga7
+ Revision: 1384398
- Update to 2.2.2 (v2) and 1.8.5 (v1)
- Backport fix to prevent pulling in Python 2 as a dependency

* Sun Feb 03 2019 ngompa <ngompa> 2.1.0-1.mga7
+ Revision: 1362867
- Rebase to libmodulemd 2.1.0 and 1.8.2

* Sun Oct 28 2018 ngompa <ngompa> 1.7.0-2.mga7
+ Revision: 1326332
- Disable running tests during package build on 32-bit ARM

* Sun Oct 28 2018 ngompa <ngompa> 1.7.0-1.mga7
+ Revision: 1326325
- Update to 1.7.0

* Tue Oct 16 2018 ngompa <ngompa> 1.6.4-1.mga7
+ Revision: 1320715
- Update to 1.6.4 and drop merged patches

* Sat Sep 15 2018 ngompa <ngompa> 1.6.3-1.mga7
+ Revision: 1259035
- Update to 1.6.3
- Sync patches from Fedora

* Sat Aug 04 2018 ngompa <ngompa> 1.6.1-1.mga7
+ Revision: 1247247
- Update to 1.6.1

* Sat Jun 30 2018 ngompa <ngompa> 1.5.2-3.mga7
+ Revision: 1240888
- Add compatibility Provides

* Sat Jun 30 2018 ngompa <ngompa> 1.5.2-2.mga7
+ Revision: 1240883
- Adapt for Mageia
- imported package libmodulemd


* Sat Jun 23 2018 Stephen Gallagher <sgallagh@redhat.com> - 1.5.2-1
- Update to libdmodulemd 1.5.2
- Don't free uninitialized memory

* Fri Jun 22 2018 Stephen Gallagher <sgallagh@redhat.com> - 1.5.1-2
- Fix buildopts property not being initialized

* Tue Jun 19 2018 Stephen Gallagher <sgallagh@redhat.com> - 1.5.1-1
- Update to version 1.5.1
- Re-enable build-time tests

* Mon Jun 18 2018 Stephen Gallagher <sgallagh@redhat.com> - 1.5.0-2
- Temporarily disable build-time tests

* Mon Jun 18 2018 Stephen Gallagher <sgallagh@redhat.com> - 1.5.0-1
- Update to version 1.5.0
- Adds support for "intents" in Modulemd.Defaults
- Adds `Modulemd.get_version()`
- Adds support for RPM whitelists in the buildopts
- Adds a new object: Modulemd.Buildopts
- Deprecates Modulemd.Module.get_rpm_buildopts()
- Deprecates Modulemd.Module.set_rpm_buildopts()
- Fixes some missing license blurbs

* Tue May 08 2018 Stephen Gallagher <sgallagh@redhat.com> - 1.4.1-1
- Update to version 1.4.1
- Improve output from modulemd-validator
- Drop upstreamed patches

* Wed Apr 25 2018 Stephen Gallagher <sgallagh@redhat.com> - 1.4.0-2
- Fix pointer math error
- Fix compilation failure in Fedora build system

* Wed Apr 25 2018 Stephen Gallagher <sgallagh@redhat.com> - 1.4.0-1
- Update to version 1.4.0
- Adds new API for returning failed YAML subdocuments
- Stop emitting log messages by default (polluting consumer logs)
- Validate RPM artifacts for proper NEVRA format
- Improve the validator tool
- Drop upstreamed patch

* Mon Apr 16 2018 Stephen Gallagher <sgallagh@redhat.com> - 1.3.0-2
- Fix serious error in modulemd-defaults emitter

* Fri Apr 13 2018 Stephen Gallagher <sgallagh@redhat.com> - 1.3.0-1
- Update to version 1.3.0
- New Public Objects:
  * Modulemd.Prioritizer - tool to merge module defaults
- New Public Functions:
  * Modulemd.SimpleSet.is_equal()
  * Modulemd.Defaults.copy()
  * Modulemd.Defaults.merge()

* Wed Apr 04 2018 Stephen Gallagher <sgallagh@redhat.com> - 1.2.0-1
- Update to version 1.2.0
- New Functions:
  * Modulemd.objects_from_file()
  * Modulemd.objects_from_string()
  * Modulemd.dump()
  * Modulemd.dumps()
  * Modulemd.Defaults.new_from_file()
  * Modulemd.Defaults.new_from_string()
- Deprecated Functions:
  * Modulemd.Module.new_all_from_file()
  * Modulemd.Module.new_all_from_file_ext()
  * Modulemd.Module.new_all_from_string()
  * Modulemd.Module.new_all_from_string_ext()
  * Modulemd.Module.dump_all()
  * Modulemd.Module.dumps_all()
- Bugfixes
  * Properly use G_BEGIN_DECLS and G_END_DECLS in headers
  * Assorted fixes for memory ownership in GObject Introspection

* Fri Mar 23 2018 Stephen Gallagher <sgallagh@redhat.com> - 1.1.3-2
- Fix missing G_END_DECL from public headers

* Mon Mar 19 2018 Stephen Gallagher <sgallagh@redhat.com> - 1.1.3-1
- Fix numerous memory leaks
- Drop upstreamed patch

* Thu Mar 15 2018 Stephen Gallagher <sgallagh@redhat.com> - 1.1.2-1
- Update to version 1.1.2
- Revert backwards-incompatible API change
- Fix version string in pkgconfig file

* Thu Mar 15 2018 Stephen Gallagher <sgallagh@redhat.com> - 1.1.1-1
- Update to version 1.1.1
- Make default stream and profiles optional
- Fixes: https://github.com/fedora-modularity/libmodulemd/issues/25
- Fixes: https://github.com/fedora-modularity/libmodulemd/issues/26
- Fixes: https://github.com/fedora-modularity/libmodulemd/issues/27

* Wed Mar 14 2018 Stephen Gallagher <sgallagh@redhat.com> - 1.1.0-1
- Update to version 1.1.0
- Adds support for handling modulemd-defaults YAML documents
- Adds peek()/dup() routines to all object properties
- Adds Modulemd.Module.dup_nsvc() to retrieve the canonical form of the unique module identifier.
- Adds support for boolean types in the XMD section
- Revert obsoletion of pythonX-modulemd packages for now

* Tue Mar 13 2018 Igor Gnatenko <ignatenkobrain@fedoraproject.org> - 1.0.4-2
- Obsolete unsupported pythonX-modulemd packages

* Tue Feb 27 2018 Stephen Gallagher <sgallagh@redhat.com> - 1.0.4-1
- Update to 1.0.4
- Rework version autodetection
- Avoid infinite loop on unparseable YAML

* Sun Feb 25 2018 Stephen Gallagher <sgallagh@redhat.com> - 1.0.3-1
- RPM components are properly emitted when no module components exist
- Parser works around late determination of modulemd version

* Fri Feb 16 2018 Stephen Gallagher <sgallagh@redhat.com> - 1.0.2-1
- Be more strict with certain parser edge-cases
- Replace popt argument processing with glib
- Drop upstreamed patches

* Thu Feb 15 2018 Stephen Gallagher <sgallagh@redhat.com> - 1.0.1-2
- Handle certain unlikely format violations

* Thu Feb 15 2018 Stephen Gallagher <sgallagh@redhat.com> - 1.0.1-1
- Support modulemd v2
- Add tool to do quick validation of modulemd
- Fix memory management
- Warn and ignore unparseable sub-documents in the YAML
- Fix several memory issues detected by Coverity scan

* Tue Feb 06 2018 Stephen Gallagher <sgallagh@redhat.com> - 0.2.2-1
- Update to libmodulemd 0.2.2
- Fix numerous minor memory leaks
- Fix issues with EOL/SL dates

* Tue Feb 06 2018 Igor Gnatenko <ignatenkobrain@fedoraproject.org> - 0.2.1-3
- Own appropriate directories

* Fri Feb 02 2018 Igor Gnatenko <ignatenkobrain@fedoraproject.org> - 0.2.1-2
- Switch to %%ldconfig_scriptlets

* Fri Jan 05 2018 Stephen Gallagher <sgallagh@redhat.com> - 0.2.1-1
- Update to libmodulemd 0.2.1
- Add 'name' property for Profiles

* Thu Oct 05 2017 Stephen Gallagher <sgallagh@redhat.com> - 0.2.0-2
- Add missing BuildRequires for gtk-doc

* Thu Oct 05 2017 Stephen Gallagher <sgallagh@redhat.com> - 0.2.0-1
- Update to libmodulemd 0.2.0
- Adds gtk-doc generated documentation
- (ABI-break) Makes all optional properties accept NULL as a value to clear
  them
- (ABI-break) Modulemd.SimpleSet takes a STRV (char **) instead of a
  GLib.PtrArray
- Fixes a bug where the name was not always set for components
- Adds support for dumping YAML from the introspected API
- Includes add/remove routines for profiles

* Sat Sep 30 2017 Igor Gnatenko <ignatenkobrain@fedoraproject.org> - 0.1.0-5
- Use %%_isa in Requires for main package from devel

* Mon Sep 18 2017 Stephen Gallagher <sgallagh@redhat.com> - 0.1.0-4
- Correct the license to MIT

* Mon Sep 18 2017 Stephen Gallagher <sgallagh@redhat.com> - 0.1.0-3
- Modifications requested during package review

* Fri Sep 15 2017 Stephen Gallagher <sgallagh@redhat.com> - 0.1.0-2
- First public release

